# SA828_Programming
This software aim to program the SA828 chip under GNU/Linux in CLI environment.

## Usage

### Read all parameters
Show you the poor parameters actually set on the device :
``` none
./sa828.py readparameter
Configuration:
==============
Channel 1:      Tx : 145.3500   Rx : 146.6000
Channel 2:      Tx : 151.7500   Rx : 151.7500
Channel 3:      Tx : 152.7500   Rx : 152.7500
Channel 4:      Tx : 153.7500   Rx : 153.7500
Channel 5:      Tx : 154.7500   Rx : 154.7500
Channel 6:      Tx : 155.7500   Rx : 155.7500
Channel 7:      Tx : 156.7500   Rx : 156.7500
Channel 8:      Tx : 157.7500   Rx : 157.7500
Channel 9:      Tx : 158.7500   Rx : 158.7500
Channel 10:     Tx : 159.7500   Rx : 159.7500
Channel 11:     Tx : 160.7500   Rx : 160.7500
Channel 12:     Tx : 161.7500   Rx : 161.7500
Channel 13:     Tx : 162.7500   Rx : 162.7500
Channel 14:     Tx : 163.7500   Rx : 163.7500
Channel 15:     Tx : 164.7500   Rx : 164.7500
Channel 16:     Tx : 165.7500   Rx : 165.7500
CTCS/CDCS :     Tx : None        Rx : None
Squelch :       8
```

### Set parameter

You can only setup channel per channel configuration.
In this case, i would like to setup Channel 1 with TX : 145.650 and RX to 145.050, no CTCSS/CDCSS and Squelch to 1.
The command look like :
```
./sa828.py setparameter --channel 1 --txfreq 145.3500 --rxfreq 146.6000 --txctcss 91.4 --rxctcss None --squelch 8
```
Feel free to show the help menu

``` none
./sa828.py setparameter --help
usage: sa828.py setparameter [-h] --channel CHANNEL --txfreq TXFREQ --rxfreq RXFREQ --txctcss TXCTCSS --rxctcss RXCTCSS --squelch SQUELCH

options:
  -h, --help         show this help message and exit
  --channel CHANNEL  Channel number, [1-16]
  --txfreq TXFREQ    Transmit frequency : format '145.4500'
  --rxfreq RXFREQ    Receive frequency : format '145.4500'
  --txctcss TXCTCSS  Transmit CTCSS : format 'None' or '88.5' or 023I or 023N
  --rxctcss RXCTCSS  Receive CTCSS : format 'None' or '88.5' or 023I or 023N
  --squelch SQUELCH  Set the Squelch : [0-8]
```

### Factory rest
This function will reset to factory settings the SA828.
```
./sa828.py reset
SA828: INFO: Resetting the radio
```
Fell free to check the new parameters to compare :
```
./sa828.py readparameter
```

### Debug mode
If you want to see the full frame sent or receive, you can add the debug flag like :
```
./sa828 --debug <command>
```

### Other parameters
You can choose an alternative serial port and baudrate if needed by using flags :
```
./sa828 --port /dev/ttyUSB4 --speed 115200 <command>
```